=== packaging/debian/control ===
Source: adflib
Section: libs
Priority: optional
Maintainer: Tomasz Wolak <tomas.wolak@gmail.com>
Uploaders: Gürkan Myczko <tar@debian.org>
Build-Depends: dh-autoreconf,
               debhelper-compat (= 13),
               autotools-dev
Standards-Version: 4.6.2
Homepage: https://github.com/lclevy/ADFlib
Vcs-Git: https://salsa.debian.org/debian/unadf.git
Vcs-Browser: https://salsa.debian.org/debian/unadf

Package: libadf
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ADFlib - shared library.
 This is a a free, portable and open implementation of the Amiga filesystem.
 .
 This package contains the shared library.

Package: libadf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libadf (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ADFlib - development files
 This is a a free, portable and open implementation of the Amiga filesystem.
 .
 This package contains the development files.

Package: libadf-utils
Architecture: any
Multi-Arch: no
Section: utils
Depends: libadf (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Utilities for Amiga disk image files (ADF).
 Utilities for ADF disk images:
 .
 adf_bitmap        - show or reconstruct volume's block allocation bitmap
 adf_floppy_create - create a new floppy disk image file
 adf_format        - format a volume of an ADF device
 adf_salvage       - show or recover/extract deleted files
 adf_show_metadata - display low-level info about a device/adf file
                     or a file/directory

Package: unadf
Architecture: any
Multi-Arch: no
Section: utils
Depends: libadf (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Extract files from an Amiga Disk File dump (.adf)
 Tool for extracting and listing files in an Amiga Disk File.
 .
 Amiga Disk File aka ADF is a file format used by Amiga computers and emulators
 to store images of disks. ADF is not really a file format but actually a
 track-by-track dump of the disk data as read by the Amiga operating system,
 and so the "format" is really fixed-width AmigaDOS data tracks appended one
 after another and held in a file.
