=== packaging/debian/watch ===
version=4
https://github.com/lclevy/ADFlib.git refs/tags/v([\d\.]+)
